<template>
  <div>
    <modal-new-pavillon></modal-new-pavillon>

    <div class="row">
      <div class="ui buttons">
        <button class="ui button">
           {{ count > 1 ? 'Pavillons' : 'Pavillon' }}
        </button>
        <div
          class="or"
          :data-text="count"
        ></div>
        <button
          class="ui positive button"
          @click="openModalNewPavillon"
        >
          Ajouter
        </button>
      </div>
    </div>
    <br/>

    <div
      class="ui" :class="columns + ' column grid'"
      v-if="count"
    >
      <div
        class="column"
        v-for="pavillon in pavillons"
        :key="pavillon._id"
      >
        <div class="ui cards">
          <pavillon-card
            :pavillon="pavillon"
            @removePavillon="removePavillon"
          ></pavillon-card>
        </div>
      </div>
    </div>

    <div class="ui header" v-else>
      Aucun pavillon présent
    </div>

  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import { adaptiveColumns } from '@/utils/utils'
import store from '@/store/Store'
import ModalNewPavillon from './ModalNewPavillon'
import PavillonCard from './PavillonCard'

export default {
  name: 'Pavillons',
  store,
  data () {
    return {
      columns: 'seven'
    }
  },
  beforeCreate () {
    store.dispatch('PavillonsStore/loadPavillons')
      .then(
        (response) => {
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
    store.dispatch('SideMenusStore/loadSideMenus')
      .then(
        (response) => {
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
  },
  created () {
    this.columns = adaptiveColumns()
  },
  mounted () {
    // eslint-disable-next-line
    $(window).on('resize', () => {
      // eslint-disable-next-line
      this.columns = adaptiveColumns()
    })
  },
  methods: {
    removePavillon (id) {
      store.dispatch('PavillonsStore/removePavillon', id)
        .then((response) => {
          this.$toastr.s(response.name + ' bien supprimé')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    openModalNewPavillon () {
      // eslint-disable-next-line
      $('#new-pavillon-modal')
        .modal('show')
    }
  },
  computed: {
    ...mapGetters({
      pavillons: 'PavillonsStore/pavillons',
      count: 'PavillonsStore/count'
    })
  },
  components: {
    PavillonCard,
    ModalNewPavillon
  }
}
</script>
